# -*- coding: utf-8 -*-
"""
/***************************************************************************
 StreamFeatureExtract
                                 A QGIS plugin
 This plugin saves the attributes of selected vector layer as a CSV file.
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2020-06-11
        git sha              : $Format:%H$
        copyright            : (C) 2020 by JD
        email                : jayabrata009@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication, pyqtSignal, QVariant
from qgis.PyQt.QtGui import QIcon, QCursor, QPixmap
from qgis.PyQt.QtWidgets import QAction, QFileDialog, QApplication, QMessageBox
from qgis.core import QgsProject, Qgis, QgsCoordinateReferenceSystem, QgsCoordinateTransform, QgsPointXY, QgsField, QgsFeatureRequest, QgsVectorDataProvider
from qgis.gui import QgsMapToolEmitPoint, QgsVertexMarker
import processing
from .resources import *
from .Stream_Feature_Extract_dialog import StreamFeatureExtractDialog
import os.path
from collections import OrderedDict
import shutil
import math
import numpy as np
import csv
from sympy.solvers import solve
from sympy import Symbol
from .models import Drainage
from osgeo import ogr

class Segment:
    def __init__(s,
        segment_id=None, valid=None, source_node=None, end_node=None, length=None,
        order=None, watershed_area=None, differential_watershed_area=None, depth=None,
        bottom_width=None, top_width=None, slope=None, q_value=None,
        sources=None, source_node_coord=None, end_node_coord=None
        #hydraulic_conductivity=None, evaporation_coefficient=None, mannigs=None, bank_flow_recession=None, potential_evaporation=None,
        ):
        s.segment_id = segment_id
        s.valid = valid
        s.source_node = source_node
        s.end_node = end_node
        s.length = length
        s.order = order
        s.watershed_area = watershed_area or 0
        s.differential_watershed_area = differential_watershed_area or 0
        s.depth = depth or 0
        s.bottom_width = bottom_width or 0
        s.top_width = top_width or 0
        s.slope = slope or 0
        s.q_value = q_value or 0
        s.sources = sources or []
        s.source_node_coord = source_node_coord or (0,0)
        s.end_node_coord = end_node_coord or (0,0)



class PointTool(QgsMapToolEmitPoint):

    def __init__(self, canvas):

        QgsMapToolEmitPoint.__init__(self, canvas)
        self.canvas = canvas

    # class PointTool(QgsMapToolEmitPoint):
    canvasClicked = pyqtSignal('QgsPointXY')
    def canvasReleaseEvent(self, event):
        # Get the click and emit a transformed point
        crs_canvas = self.canvas.mapSettings().destinationCrs()
        point_canvas_crs = event.mapPoint()
        wgs = QgsCoordinateReferenceSystem.fromEpsgId(32643)
        xformer = QgsCoordinateTransform(crs_canvas, wgs, QgsProject.instance())
        point_wgs = xformer.transform(point_canvas_crs)
        self.canvasClicked.emit(point_wgs)




class StreamFeatureExtract:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'StreamFeatureExtract_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Stream Feature Extract')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('StreamFeatureExtract', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToVectorMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/Stream_Feature_Extract/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Stream Feature Extract as CSV'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginVectorMenu(
                self.tr(u'&Stream Feature Extract'),
                action)
            self.iface.removeToolBarIcon(action)
            
            
    def select_output_file(self):
        filename, _filter = QFileDialog.getSaveFileName(
        self.dlg, "Select output file ","", '')
        self.dlg.outputFilePath.setText(filename)
        
    
    def select_runoff_file(self):
        rfFilename, _rfFilter = QFileDialog.getOpenFileName(
        self.dlg, "Select Runoff File","", "*.csv")
        self.dlg.runoffFilePath.setText(rfFilename)

    def select_coordinate_file(self):
        coordFilename, _rfFilter = QFileDialog.getOpenFileName(
        self.dlg, "Select Coordinate File","", "*.csv")
        self.dlg.coordinatesFilePath.setText(coordFilename)
        
    
    def _on_map_click(self):
        self.dlg.hide()
        self.point_tool = PointTool(self.iface.mapCanvas())
        self.iface.mapCanvas().setMapTool(self.point_tool)
        self.point_tool.canvasClicked.connect(self._writeLineWidget)
    
    def _writeLineWidget(self, point):
        x, y = point
        
        self.point_tool.canvasClicked.disconnect()
        
        self.dlg.show()
        self.dlg.inputCoordinateValue.setText("{0:.6f}, {1:.6f}".format(x, y))
    
    
    
    
    #####################(stream_network[i],temp, pixelSize, dem, j, root_path1, path2,maxPixel)
    def getDepth(self, stream_segment, segment, stepSize, dem, j, root_path1, path2,maxPixel): # step size = pixel size
        f=0        
        coor_dir = {}
        depth_sum = 0
        depthCount = 0
        elv = {}
        minDist1 = -1
        minDist2 = -1
        maxDepth = 0



        for i in segment:
            x, y = i.geometry().asPoint().x(), i.geometry().asPoint().y()
            

            if (x,y) != stream_segment.end_node_coord and (x,y) !=  stream_segment.source_node_coord:

                coor_dir[i['id']] = (x,y)

                dist1 = math.sqrt( ((stream_segment.end_node_coord[0]-x)**2)+((stream_segment.end_node_coord[1]-y)**2) )
                if minDist1 !=-1:
                    if minDist1>dist1:
                        # print("New minDist1")
                        minDist1 = dist1
                        lastPoint = i['id']
                else:
                    # print("Initialize minDist1")
                    minDist1 = dist1
                    lastPoint = i['id']
                # print(minDist1)

                dist2 = math.sqrt( ((stream_segment.source_node_coord[0]-x)**2)+((stream_segment.source_node_coord[1]-y)**2) )
                #print(j,i['id']," -> ",coor_dir[i['id']],dist2)
                if minDist2 !=-1:
                    if minDist2>dist2:
                        # print("New minDist2")
                        minDist2 = dist2
                        firstPoint = i['id']
                else:
                    # print("Initialize minDist2")
                    minDist2 = dist2
                    firstPoint = i['id']
                # print(minDist2)

            #####################################################################################
            
            
            
            
            ###################################For depth calculation
                xd,yd = stepSize,0
                maxItr = maxPixel
                if f==0:
                    x_prev,y_prev = x,y
                
                    firstHeight, temp = dem.dataProvider().sample(QgsPointXY(x,y), 1)
                    elv[i['id']] = firstHeight
                
                    f=1
                else:
                    x_move,y_move = x - x_prev,y-y_prev
                    x_prev,y_prev = x,y
                
                    if x_move==0 and y_move!=0:
                        #line => vertical line => move along x axis
                        #line = '--'
                        xd,yd = stepSize,0
                    elif x_move!=0 and y_move==0:
                        #line => horizental line => move along y axis
                        #line = '|'
                        xd,yd = 0,stepSize
                    elif (x_move>0 and y_move>0) or (x_move<0 and y_move<0):
                        #line = '\\'
                        xd,yd = stepSize,-stepSize
                    elif (x_move<0 and y_move>0) or (x_move>0 and y_move<0):
                        #line = '/'  
                        xd,yd = stepSize,stepSize
                
                
                
                    xa,ya = xb,yb = x,y

                    baseHeight, temp = dem.dataProvider().sample(QgsPointXY(x,y), 1)
                    elv[i['id']] = baseHeight


    
                    height_a = [baseHeight]
                    height_b = [baseHeight]
                    itr_a=itr_b=0
                
                    while itr_a<maxItr:
                        xa,ya = xa+xd,ya+yd
                        height_a_curr, temp = dem.dataProvider().sample(QgsPointXY(xa,ya), 1)
                        if not math.isnan(height_a_curr):
                            height_a.append(height_a_curr)
                        itr_a=itr_a+1
                    
                
                    while itr_b<maxItr:
                        xb,yb = xb-xd,yb-yd
                        height_b_curr, temp = dem.dataProvider().sample(QgsPointXY(xb,yb), 1)
                        if not math.isnan(height_b_curr):
                            height_b.append(height_b_curr)
                        itr_b=itr_b+1
                    
                
                    depth_a = max(height_a) - baseHeight
                    depth_b = max(height_b) - baseHeight

                    if depth_a and depth_b:
                        depth = min(depth_a,depth_b)
                    else:
                        depth = max(depth_a,depth_b)

                    #print(j,i['id'],depth,coor_dir[i['id']],depth_sum,depthCount)
                    
                    if depth and depth>maxDepth:
                        maxDepth = depth

                        # depth_sum, depthCount = depth_sum+depth, depthCount+1
                        
        
        
        ####################Basin Coordinate ###############################


        #print("last Point of ",j," - ",lastPoint,coor_dir[lastPoint]," dist - ",minDist1)
        #print(coor_dir[lastPoint])
        #print("first Point of ",j," - ",firstPoint,coor_dir[firstPoint]," dist - ",minDist2)
        # bcoor1 = coor_dir[max(coor_dir.keys())]     # the last point is the point with max id. it is bcoor1 => the point on which the watershed is computed
        # print("Basin coord earlier: ",bcoor1)
        bcoor1 = coor_dir[lastPoint]                  # the point closest to the end point, it is bcoor1 => the point on which the watershed is computed
        # print("Basin coord now: ",bcoor1)
        

        #Generate Watershed raster w.r.t bcoor1
        param6 = { 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'coordinates' : str(bcoor1), 'input' : root_path1+'DrainageDirection.tif', 'output' :  path2+'RBasin'+str(j)+'.tif'}
        processing.run("grass7:r.water.outlet",param6)
        
        bcoor2 = (0,0)

        basinR = self.iface.addRasterLayer(path2+'RBasin'+str(j)+'.tif','')

        #check whether the watershed covers the entire stream or not. If not compute 2nd point (bcoor1) to generate watershed w.r.t this point
        for i in sorted(coor_dir.keys()):  #if flag else sorted(coor_dir.keys())[:-1]:
            val, temp = basinR.dataProvider().sample(QgsPointXY(coor_dir[i][0],coor_dir[i][1]), 1)
            if math.isnan(val):
                bcoor2 = coor_dir[i]

        QgsProject.instance().removeMapLayer(basinR)

        
        
        if bcoor2 != (0,0):
            # print(j," : ",bcoor1,bcoor2)
            #Convert Watershed raster into vector : (just to give it a different name) = VBasin.shp
            param7 = { '-b' : False, '-s' : False, '-t' : False, '-v' : False, '-z' : False, 'GRASS_OUTPUT_TYPE_PARAMETER' : 0, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'column' : 'value', 'input' : path2+'RBasin'+str(j)+'.tif', 'output' : path2+'VBasin'+str(j)+'.shp', 'type' : 2 }
            processing.run("grass7:r.to.vect",param7)

            #Generate Watershed raster w.r.t bcoor2
            param8 = { 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'coordinates' : str(bcoor2), 'input' : root_path1+'DrainageDirection.tif', 'output' :  path2+'secRBasin'+str(j)+'.tif'}
            processing.run("grass7:r.water.outlet",param8)

            #Convert Watershed raster into vector
            param9 = { '-b' : False, '-s' : False, '-t' : False, '-v' : False, '-z' : False, 'GRASS_OUTPUT_TYPE_PARAMETER' : 0, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'column' : 'value', 'input' : path2+'secRBasin'+str(j)+'.tif', 'output' : path2+'secVBasin'+str(j)+'.shp', 'type' : 2 }
            processing.run("grass7:r.to.vect",param9)

            basin1 = self.iface.addVectorLayer(path2+'VBasin'+str(j)+'.shp','','ogr')
            basin2 = self.iface.addVectorLayer(path2+'secVBasin'+str(j)+'.shp','','ogr')

            for i in basin1.getFeatures():
                if not i.geometry().isGeosValid():
                    param9a = { 'INPUT' :basin1 , 'OUTPUT' : path2+'VBasinFixed'+str(j)+'.shp'}
                    processing.run("native:fixgeometries",param9a)
                    QgsProject.instance().removeMapLayer(basin1)
                    basin1 = self.iface.addVectorLayer(path2+'VBasinFixed'+str(j)+'.shp','','ogr')


            for i in basin2.getFeatures():
                if not i.geometry().isGeosValid():
                    param9b = { 'INPUT' :basin2 , 'OUTPUT' : path2+'secVBasinFixed'+str(j)+'.shp'}
                    processing.run("native:fixgeometries",param9b)
                    QgsProject.instance().removeMapLayer(basin2)
                    basin2 = self.iface.addVectorLayer(path2+'secVBasinFixed'+str(j)+'.shp','','ogr')
            
            

            #Take union of these 2 watershed vectors
            param10 = { 'INPUT' : basin1, 'OUTPUT' : path2+'Basin'+str(j)+'.shp', 'OVERLAY' : basin2, 'OVERLAY_FIELDS_PREFIX' : '' }
            processing.run("native:union",param10)
        else:
            # print(j," : ",bcoor1)
            #Convert Watershed raster into vector: Here the name is Basin.shp
            param7 = { '-b' : False, '-s' : False, '-t' : False, '-v' : False, '-z' : False, 'GRASS_OUTPUT_TYPE_PARAMETER' : 0, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'column' : 'value', 'input' : path2+'RBasin'+str(j)+'.tif', 'output' : path2+'Basin'+str(j)+'.shp', 'type' : 2 }
            processing.run("grass7:r.to.vect",param7)


        basin = self.iface.addVectorLayer(path2+'Basin'+str(j)+'.shp','','ogr')
        bArea = sum(i.geometry().area() for i in basin.getFeatures())
        QgsProject.instance().removeMapLayer(basin)
        
        try:
            #elvdif = abs(elv[0]-elv[-1])    # it may give inconsistant result 
            #elvdif = max(elv) - min(elv)   
            elvdif = abs(elv[firstPoint] - elv[lastPoint])
        except:
            elvdif = 0                      # in case the segment contains only one point, there will be no elevation data in elv[] (as the first point is ignored)


        if maxDepth:
            return maxDepth, elvdif, bArea
        else:
            return 0.5, elvdif, bArea
        
    
    def getPeakRunoff(self, file):
        try:
            with open (file) as csv_file:
                csv_reader = csv.reader(csv_file, delimiter=',')
                next(csv_reader)
                peakRunoff = max([ float(row[9])+float(row[12]) for row in csv_reader if row[9] != '' or row[12] != ''])
                print("Peak Runoff: ",peakRunoff)
        except:
            QMessageBox.critical(self.iface.mainWindow(),
                         'Runoff Input CSV file Error!',
                         "Can not extract peakrunoff from csv file.\nCheck the file format.\nMake sure the CSV has delimiter ',' and primaty and secondary sunoffs are in 10th and 13th column (column starting from 1)")
            return None
        return peakRunoff


    # It saves the input coordinates into "input_coordinate_list" list from input coordinate csv file and return the list
    def getInputCoordinates(self, file):
        try:
            with open (file) as csv_file:
                csv_reader = csv.reader(csv_file, delimiter=',')
                next(csv_reader)
                coordinates_list = [(float(row[0]),float(row[1])) for row in csv_reader if row[0] != '' and row[1] != '']
        except:
            QMessageBox.critical(self.iface.mainWindow(),
                         'Coordinates Input CSV file Error!',
                         "Can not extract coordinates from csv file.\nCheck the file format.\nMake sure the CSV has delimiter ',' and X and Y sunoffs are in 1st and 2nd column (column starting from 1)")
            return None
        return coordinates_list


    def computeFeatures(self,qValue, depth, slope, n,sideSlope,order):

        #print(qValue, depth, slope, n,sideSlope,order)
        def func( x ): 
            return ((D*x+C1)**5-(C3**3)*(x+C2)**2)
  
        def derivFunc( x ): 
            return (5*D*(D*x+C1)**4-(C3**(1/3))*2*(x+C2)) 
  
        # Function to find the root 
        def newtonRaphson( x ): 
            h = func(x) / derivFunc(x) 
            itr = 0
            while abs(h) >= 0.0001 and itr <=100:
                #print(x)
                itr+=1 
                h = func(x)/derivFunc(x) 
                # x(i+1) = x(i) - f(x) / f'(x) 
                x = x - h 
            return round(x,4)

        D = depth
        C1 = sideSlope*depth**2
        C2 = 2*depth*math.sqrt(1+sideSlope**2)
        C3 = qValue*n/math.sqrt(slope)

        # Driver program to test above 
        x0 = -20 # Initial values assumed 
        width = newtonRaphson(x0)
        #print(D, C1, C2, C3 ,width)
        #bWidth = width[0] if width[0]>0 else order+(order-1) #if width<0 then width = 1 if order==1 and width =3 if order==2
        #bWidth = width[0]
        #print("****************************Width: ",width)
        bWidth = width if width>0 else order+(order-1) #if width<0 then width = 1 if order==1 and width =3 if order==2
        tWidth = 2*sideSlope*depth+bWidth
        
        return bWidth,tWidth

    def getQValue(self,id,stream_network,peakRunoff):  #peakrunoff in mm & area in m^2
        if stream_network[id].q_value:
            return stream_network[id].q_value
        else:
            areaInHa = stream_network[id].differential_watershed_area/10000                           #converting area into Hactare
            q = peakRunoff*areaInHa/360
            #print('id: ',id,' order: ',order[id],' q: ',q)
            if stream_network[id].order == 1:
                stream_network[id].q_value = q
                return stream_network[id].q_value
            else:
                stream_network[id].q_value = q+sum( self.getQValue(i,stream_network,peakRunoff) for i in stream_network[id].sources)
                return stream_network[id].q_value
        

    def snap(self,stream,points):

        final_coordinate_list = []

        for point in points:
            flag = 0
            for i in stream.getFeatures():
                feat = i.geometry().closestSegmentWithContext(QgsPointXY(point[0],point[1]))
                #my_tuplas.append(tupla)
                if flag:
                    if feat[0]<minDist:
                        minDist = feat[0]
                        #print(minDist)
                        coordinate=feat[1]
                else:
                    minDist = feat[0]
                    #print(minDist)
                    coordinate=feat[1]
                    flag = 1
            #print(minDist,coor,points[1])
            final_coordinate_list.append(str(coordinate[0])+","+str(coordinate[1]))

        return final_coordinate_list

    def makeDirectory(self,filename,subfolder,count):
        path = filename+subfolder+count+'/'
        path1 = path+'_temp_/'
        #folder to save stream segment files
        path2 = path1+'Basins/'
        #create a temporary folder
        try:
            os.mkdir(path)
        except:
            shutil.rmtree(path)
            os.mkdir(path)
        try:
            os.mkdir(path1)
        except:
            shutil.rmtree(path1)
            os.mkdir(path1)
        try: 
            os.mkdir(path2)
        except:
            shutil.rmtree(path2)
            os.mkdir(path2)
        #Set Output file Names
        filename2 = path+'Stream'+count+'.shp'
        filename2_ = path+'Stream-grass'+count+'.gpkg'
        filename2_1 = path+'Stream-grass'+count+'.shp'
        filename2_1_1 = path+'Junctionpoints'+count+'.shp'
        resultFileName = path+'Stream Features'+count+'.csv'
        resultFileName2 = path+'Stream Flow Data'+count+'.csv'

        return path,path1,path2,filename2,filename2_,filename2_1,resultFileName,resultFileName2



    def run(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = StreamFeatureExtractDialog()
            #######################################################################
            self.dlg.finished.connect(self.result)
            self.dlg.map_button.clicked.connect(self._on_map_click)
            self.dlg.pushButton.clicked.connect(self.select_output_file)
            self.dlg.pushButton_2.clicked.connect(self.select_runoff_file)
            self.dlg.pushButton_3.clicked.connect(self.select_coordinate_file)
            
            #######################################################################
            
        ###########################################################################
        # Fetch the currently loaded layers
        layers = QgsProject.instance().layerTreeRoot().children()
        # Clear the contents of the comboBox from previous runs
        self.dlg.comboBox.clear()
        self.dlg.outputFilePath.clear()
        self.dlg.runoffFilePath.clear()
        self.dlg.coordinatesFilePath.clear()
        self.dlg.inputCoordinateValue.clear()
        self.dlg.thresholdValue.clear()
        self.dlg.thresholdValueForStream.clear() 
        self.dlg.maxWidthValue.clear()
        self.dlg.minLengthValue.clear()
        self.dlg.frictionDeepAquiferValue.clear()
        self.dlg.hydraulicConductivityValue.clear()
        self.dlg.evaporationCoefficientValue.clear()
        self.dlg.mannigsValue.clear()
        self.dlg.bankFlowRecessionValue.clear()
        self.dlg.potentialEvaporationValue.clear()
        self.dlg.sideSlopeValue.clear() 
        # Populate the comboBox with names of all the loaded layers
        self.dlg.comboBox.addItems([layer.name() for layer in layers])
        
        
        
        
        ############################################################################
        
        # show the dialog
        ########################self.dlg.show()
        # Run the dialog event loop
        ########################result = self.dlg.exec_()
        self.dlg.open()
        # See if OK was pressed
        ############################################################################
        
        
    def result(self, result):
        if result:
            # Plugin functionality implemented here
            
            # Get output directory path (filename), Input runoff file path (runoffFile) and Input coordinatw file path (coordsFile) 
            filename = self.dlg.outputFilePath.text()
            runoffFile = self.dlg.runoffFilePath.text()
            coordsFile = self.dlg.coordinatesFilePath.text()
            

            # Set the variable values from the inputs text boxes. If no input set default value
            try:
                threshold = int(self.dlg.thresholdValue.text())
            except:
                threshold = 500
            try:
                threshold2 = int(self.dlg.thresholdValueForStream.text())
            except:
                threshold2 = 5
            try:
                maxWidth = int(self.dlg.maxWidthValue.text())
            except:
                maxWidth = 1
            try:
                minLength = int(self.dlg.minLengthValue.text())
            except:
                minLength = 200
            try:
                frictionDeepAquifer = int(self.dlg.frictionDeepAquiferValue.text())
            except:
                frictionDeepAquifer = 0.5
            try:
                hydraulicConductivity = int(self.dlg.hydraulicConductivityValue.text())
            except:
                hydraulicConductivity = 5
            try:
                evaporationCoefficient = int(self.dlg.evaporationCoefficientValue.text())
            except:
                evaporationCoefficient = 0.1
            try:
                mannigs = int(self.dlg.mannigsValue.text())
            except:
                mannigs = 0.05
            try:
                bankFlowRecession = int(self.dlg.bankFlowRecessionValue.text())
            except:
                bankFlowRecession = 0.3
            try:
                potentialEvaporation = int(self.dlg.potentialEvaporationValue.text())
            except:
                potentialEvaporation = 1
            try:
                sideSlope = int(self.dlg.sideSlopeValue.text())
            except:
                sideSlope = 1


            
            # Check all requirements are fulfilled. In case something is missing, end execution and show error message
            if filename == '':
                QMessageBox.critical(self.iface.mainWindow(),
                         'No Destination Error',
                         "Please Select Valid Destination for output file. ")
                return None

            if runoffFile == '':
                QMessageBox.critical(self.iface.mainWindow(),
                         'No Input Runoff file Error',
                         "Please Select Input Runoff File. ")
                return None
                

            # Get single coordinate
            xy = self.dlg.inputCoordinateValue.text()

            # If neither single coordinate nor coordinate file is given stop execution
            if xy == '' and coordsFile == '':
                QMessageBox.critical(self.iface.mainWindow(),
                         'No Coordinate Error',
                         "Invalid coordinates!\n Either pick a single coordinate or selest a cordinate file")
                return None

            # If both single coordinate and coordinate file are given stop execution
            if xy != '' and coordsFile != '':
                QMessageBox.critical(self.iface.mainWindow(),
                         'Multiple Coordinates Error',
                         "Can not process both coordinate inputs!\nEither pick a single coordinate or selest a cordinate file")
                return None



            # list to save input coordinates in tuple format
            input_coordinate_list =[]

            # add input coordinates in input_coordinate_list in tuple format
            if xy != '' and coordsFile == '':
                input_coordinate_list.append((float(xy.split(',')[0]),float(xy.split(',')[1])))
            else:
                input_coordinate_list = self.getInputCoordinates(coordsFile)
                if not input_coordinate_list or input_coordinate_list == []:
                    return None 
                    
            print(input_coordinate_list)



            #path to the Main folder
            root_path = filename+'/'
            #to save the common files that will be generated once like - FillDEM.tif, DrainageDirection.tif
            root_path1 = root_path+'_temp_/'
            
            #create the directories
            try:
                os.mkdir(root_path)
            except:
                shutil.rmtree(root_path)
                os.mkdir(root_path)
            try:
                os.mkdir(root_path1)
            except:
                shutil.rmtree(root_path1)
                os.mkdir(root_path1)


            
            # Requirments checking and variable initialization are done.
            # Start generating required layers
            if 1:
                
                # Get the DEM object
                layers = QgsProject.instance().layerTreeRoot().children()
                selectedLayerIndex = self.dlg.comboBox.currentIndex()
                selectedLayer = layers[selectedLayerIndex].layer()
                # Get Pixel size of the input DEM
                pixelSize = selectedLayer.rasterUnitsPerPixelX()
                
                
                # fill sinks: Generate sink free DEM from the input DEM
                param0 = { 'DEM' : selectedLayer, 'DZFILL' : 0.01, 'FILLED' : root_path1+'fillDEM.sdat', 'SINKS' : 'TEMPORARY_OUTPUT' }
                processing.run("saga:fillsinksqmofesp",param0)
                
                
                # generate Drainage Direction & GRASS stream raster: required for Basin generation
                # param1a = { '-4' : False, '-a' : False, '-b' : False, '-m' : False, '-s' : True, 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'blocking' : None, 'convergence' : 5, 'depression' : None, 'disturbed_land' : None, 'drainage' : root_path1+'DrainageDirection.tif', 'elevation' : root_path1+'fillDEM.sdat', 'flow' : None, 'max_slope_length' : None, 'memory' : 300, 'stream' : root_path1+'GrassStreamRaster.tif', 'threshold' : threshold }
                param1a = { '-4' : False, '-a' : False, '-b' : False, '-m' : False, '-s' : True, 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'blocking' : None, 'convergence' : 5, 'depression' : None, 'disturbed_land' : None, 'drainage' : root_path1+'DrainageDirection.tif', 'elevation' : root_path1+'fillDEM.sdat', 'flow' : None, 'max_slope_length' : None, 'memory' : 300, 'stream' : root_path1+'GrassStreamRaster.tif', 'accumulation':root_path1+'AccumulationRaster.tif', 'threshold' : threshold }                
                processing.run("grass7:r.watershed",param1a)



                param1aa = { 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'input' : root_path1+'GrassStreamRaster.tif', 'iterations' : 200, 'output' : root_path1+'GrassStreamRasterThinned.tif' }
                processing.run("grass7:r.thin",param1aa)

                # generate Grass Stream: Basines are generated according to this stream. So the input coordinates need to be mapped onto this stream
                param1b = { '-b' : False, '-s' : False, '-t' : False, '-v' : False, '-z' : False, 'GRASS_OUTPUT_TYPE_PARAMETER' : 2, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'column' : 'value', 'input' : root_path1+'GrassStreamRasterThinned.tif', 'output' : root_path1+'GrassStreamVector.shp', 'type' : 0 }
                processing.run("grass7:r.to.vect",param1b)


                # load Grass Stream
                gstream = self.iface.addVectorLayer(root_path1+'GrassStreamVector.shp','','ogr')

                # map the input coordinates on the stream generated by GRASS method
                finalCoordinateList = self.snap(gstream,input_coordinate_list)
                for i in finalCoordinateList:
                    print(i.split(",")[0],i.split(",")[1])

                # Remove Grass Stream
                QgsProject.instance().removeMapLayer(gstream)


                # for each coordinate generate stream and extract features
                for coordinate in range(len(finalCoordinateList)):
                    print(coordinate+1," - ",finalCoordinateList[coordinate])
                    subfolder = str(os.path.split(filename)[1])

                    # for each iteration generate different directories to save the files. Format: ...output_file/"output_file - serial no"
                    # path,path1,path2,filename2,resultFileName,resultFileName2 = self.makeDirectory(root_path,subfolder,"-"+str(coordinate+1))
                    path,path1,path2,filename2,filename2_,filename2_1,resultFileName,resultFileName2 = self.makeDirectory(root_path,subfolder,"-"+str(coordinate+1))
                    print("Path to the output directory: ",path)


                    # generate Basin for the coordinate: to get the boundary of the stream to be generated
                    param2 = { 'GRASS_RASTER_FORMAT_META' : '', 'GRASS_RASTER_FORMAT_OPT' : '', 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'coordinates' : finalCoordinateList[coordinate], 'input' : root_path1+'DrainageDirection.tif', 'output' :  path+'SourceBasin.tif'}
                    processing.run("grass7:r.water.outlet",param2)
                    

                    # convert basin raster to vector: to check if the area of the basin is valid (not too small)
                    param3 = { '-b' : False, '-s' : False, '-t' : False, '-v' : False, '-z' : False, 'GRASS_OUTPUT_TYPE_PARAMETER' : 0, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'column' : 'value', 'input' : path+'SourceBasin.tif', 'output' : path1+'BasinArea.shp', 'type' : 2 }
                    processing.run("grass7:r.to.vect",param3)
                    
                    
                    # Load generated basine, get besin area and check validity
                    basinVect = self.iface.addVectorLayer(path1+'BasinArea.shp','','ogr')
                    areaB = sum(i.geometry().area() for i in basinVect.getFeatures())
                    QgsProject.instance().removeMapLayer(basinVect)
                    
                    # here the threshold is set as 0 but it can be increases as small area will lead to no stream network
                    if areaB ==0:
                        QMessageBox.critical(self.iface.mainWindow(),
                             'Invalid Point Selected',
                             "No watershed Area for the selected point") 
                        return None
                    
                    print("start clipping")
                    # DEM for basin area: clip the fillDEM by the basin to set boundary for the stream network
                    param4 = { 'ALPHA_BAND' : False, 'CROP_TO_CUTLINE' : True, 'DATA_TYPE' : 0, 'EXTRA' : '', 'INPUT' : root_path1+'fillDEM.sdat', 'KEEP_RESOLUTION' : False, 'MASK' : path1+'BasinArea.shp', 'MULTITHREADING' : False, 'NODATA' : None, 'OPTIONS' : '', 'OUTPUT' : path1+'BasinRaster.tif', 'SET_RESOLUTION' : False, 'SOURCE_CRS' : None, 'TARGET_CRS' : None, 'X_RESOLUTION' : None, 'Y_RESOLUTION' : None }
                    processing.run("gdal:cliprasterbymasklayer",param4)

                    # ACCUMULATION for basin area: clip the Accumulation by the basin to set boundary for the stream network
                    param4_acc = { 'ALPHA_BAND' : False, 'CROP_TO_CUTLINE' : True, 'DATA_TYPE' : 0, 'EXTRA' : '', 'INPUT' : root_path1+'AccumulationRaster.tif', 'KEEP_RESOLUTION' : False, 'MASK' : path1+'BasinArea.shp', 'MULTITHREADING' : False, 'NODATA' : None, 'OPTIONS' : '', 'OUTPUT' : path1+'BasinRasterAccumulation.tif', 'SET_RESOLUTION' : False, 'SOURCE_CRS' : None, 'TARGET_CRS' : None, 'X_RESOLUTION' : None, 'Y_RESOLUTION' : None }
                    processing.run("gdal:cliprasterbymasklayer",param4_acc)

                    param4_dir = { 'ALPHA_BAND' : False, 'CROP_TO_CUTLINE' : True, 'DATA_TYPE' : 0, 'EXTRA' : '', 'INPUT' : root_path1+'DrainageDirection.tif', 'KEEP_RESOLUTION' : False, 'MASK' : path1+'BasinArea.shp', 'MULTITHREADING' : False, 'NODATA' : None, 'OPTIONS' : '', 'OUTPUT' : path1+'BasinRasterDirection.tif', 'SET_RESOLUTION' : False, 'SOURCE_CRS' : None, 'TARGET_CRS' : None, 'X_RESOLUTION' : None, 'Y_RESOLUTION' : None }
                    processing.run("gdal:cliprasterbymasklayer",param4_dir)

                    param4_str = { 'ALPHA_BAND' : False, 'CROP_TO_CUTLINE' : True, 'DATA_TYPE' : 0, 'EXTRA' : '', 'INPUT' : root_path1+'GrassStreamRaster.tif', 'KEEP_RESOLUTION' : False, 'MASK' : path1+'BasinArea.shp', 'MULTITHREADING' : False, 'NODATA' : None, 'OPTIONS' : '', 'OUTPUT' : path1+'BasinRasterStream.tif', 'SET_RESOLUTION' : False, 'SOURCE_CRS' : None, 'TARGET_CRS' : None, 'X_RESOLUTION' : None, 'Y_RESOLUTION' : None }
                    processing.run("gdal:cliprasterbymasklayer",param4_str)

                    
                    # generate Stream Network and junction points layer : this stream is the main layer we will add more features to this
                    # param5 = { 'BASIN' : 'TEMPORARY_OUTPUT', 'BASINS' : 'TEMPORARY_OUTPUT', 'CONNECTION' : 'TEMPORARY_OUTPUT', 'DEM' :  path1+'BasinRaster.tif', 'DIRECTION' : 'TEMPORARY_OUTPUT', 'NODES' : path1+'JunctionPoints.shp', 'ORDER' : 'TEMPORARY_OUTPUT', 'SEGMENTS' :  filename2, 'THRESHOLD' : threshold2 }
                    # processing.run("saga:channelnetworkanddrainagebasins",param5)

                    param5_grass = { 'GRASS_OUTPUT_TYPE_PARAMETER' : 1, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'accumulation' : path1+'BasinRasterAccumulation.tif', 'direction' : path1+'BasinRasterDirection.tif', 'elevation' : path1+'BasinRaster.tif', 'strahler' : None, 'stream_rast' : path1+'BasinRasterStream.tif', 'stream_vect' : filename2_, 'topo' : None }
                    processing.run("grass7:r.stream.order", param5_grass)
                    print("----here-----1")
                    source = ogr.Open(filename2_,update=False)
                    drv = ogr.GetDriverByName( 'ESRI Shapefile' )
                    for i in source:
                        LayerName = i.GetName() 
                        inlyr = source.GetLayer( LayerName )
                        outds = drv.CreateDataSource(path1+'JunctionPoints-grass.shp')
                        outlyr = outds.CopyLayer(inlyr,LayerName)
                    del inlyr,outlyr,outds 


                    param5_grass = { 'GRASS_OUTPUT_TYPE_PARAMETER' : 2, 'GRASS_REGION_CELLSIZE_PARAMETER' : 0, 'GRASS_REGION_PARAMETER' : None, 'GRASS_VECTOR_DSCO' : '', 'GRASS_VECTOR_EXPORT_NOCAT' : False, 'GRASS_VECTOR_LCO' : '', 'accumulation' : path1+'BasinRasterAccumulation.tif', 'direction' : path1+'BasinRasterDirection.tif', 'elevation' : path1+'BasinRaster.tif', 'strahler' : None, 'stream_rast' : path1+'BasinRasterStream.tif', 'stream_vect' : filename2_, 'topo' : None }
                    processing.run("grass7:r.stream.order", param5_grass)
                    print("----here-----2")
                    source = ogr.Open(filename2_,update=False)
                    drv = ogr.GetDriverByName( 'ESRI Shapefile' )
                    for i in source:
                        LayerName = i.GetName() 
                        inlyr = source.GetLayer( LayerName )
                        outds = drv.CreateDataSource(filename2_1)
                        outlyr = outds.CopyLayer(inlyr,LayerName)
                    del inlyr,outlyr,outds 
                    print("----here-----3")
                    
                    # add stream network layer:
                    # stream = self.iface.addVectorLayer(filename2,'','ogr')
                    stream_grass = self.iface.addVectorLayer(filename2_1,'','ogr')
                    stream_grass_pt = self.iface.addVectorLayer(path1+'JunctionPoints-grass.shp','','ogr')

                    # remove Segments with length < minLength : requirs - qgis.core.QgsVectorDataProvider
                    # caps = stream.dataProvider().capabilities()
                    caps_grass = stream_grass.dataProvider().capabilities()
                    caps_grass_pt = stream_grass_pt.dataProvider().capabilities()

                    # store the "SEGMENT ID" of the first order segments that has length < minLength
                    toBeDeleted = []
                    # store the end nodes of the deleted segments (to make the pair of segments that need to be merged)
                    deletedNode = []
                    # assign new "SEGMENT ID" after deleting the segments
                    newId=1
                    # store Segment class object
                    stream_network = {}
                    '''
                    if caps & QgsVectorDataProvider.DeleteFeatures:
                        stream.startEditing()
                        for feat in stream.getFeatures():
                            if feat['LENGTH'] < minLength and feat["ORDER"] == 1:               #Finding first order segments that has length < minLength 
                                toBeDeleted.append(feat.id())
                                deletedNode.append(feat["NODE_B"])
                            else:
                                feat["SEGMENT_ID"] = newId                                      #Assigning new "SEGMENT ID"
                                stream_network[newId] = Segment(segment_id = feat["SEGMENT_ID"],
                                    source_node = feat["NODE_A"],end_node = feat["NODE_B"],
                                    length = feat["LENGTH"], order = feat["ORDER"], valid = round(feat["LENGTH"],3)>round(pixelSize*math.sqrt(2),3))
                                newId+=1
                                stream.updateFeature(feat)
                        stream.commitChanges()
                        res = stream.dataProvider().deleteFeatures(toBeDeleted)                 #Segments deleted

                    # deleting unnecessary fields
                    if caps & QgsVectorDataProvider.DeleteAttributes:
                        res = stream.dataProvider().deleteAttributes([3,5])
                        stream.updateFields()

                    '''

                    # store the "SEGMENT ID" of the first order segments that has length < minLength
                    toBeDeleted_grass = []
                    # store the end nodes of the deleted segments (to make the pair of segments that need to be merged)
                    deletedNode_grass = []
                    # assign new "SEGMENT ID" after deleting the segments
                    newId_grass=1
                    # store Segment class object
                    stream_network_grass = {}

                    layer_provider=stream_grass.dataProvider()
                    layer_provider.addAttributes([QgsField("SEGMENT_ID",QVariant.Int)])
                    stream_grass.updateFields()

                    coord_mapping = {}

                    if caps_grass & QgsVectorDataProvider.DeleteFeatures:
                        stream_grass.startEditing()
                        for feat in stream_grass.getFeatures():

                            if feat['length'] < minLength and feat["strahler"] == 1:               #Finding first order segments that has length < minLength 
                                toBeDeleted_grass.append(feat.id())
                                # deletedNode_grass.append(feat["NODE_B"])
                            else:
                                #Node B is next_stream node A is stream
                                feat["SEGMENT_ID"] = newId_grass #Assigning new "SEGMENT ID"
                                # coord_mapping[feat[stream]] = (feat.geometry().asPoint().x(), feat.geometry().asPoint().y())
                                if feat["next_strea"]==-1:
                                    end = feat['stream']
                                else:
                                    end=feat['next_strea']
                                stream_network_grass[newId_grass] = Segment(segment_id = feat["SEGMENT_ID"],
                                    source_node = feat["stream"],end_node =end ,
                                    length = feat["length"], order = feat["strahler"], valid = round(feat["length"],3)>round(pixelSize*math.sqrt(2),3))
                                newId_grass+=1
                                stream_grass.updateFeature(feat)
                        stream_grass.commitChanges()
                        res_grass = stream_grass.dataProvider().deleteFeatures(toBeDeleted_grass)                 #Segments deleted

                    # deleting unnecessary fields
                    if caps_grass & QgsVectorDataProvider.DeleteAttributes:
                        # res_grass = stream_grass.dataProvider().deleteAttributes([3,5])
                        stream_grass.updateFields()
                    if caps_grass_pt & QgsVectorDataProvider.DeleteFeatures:
                        stream_grass_pt.startEditing()
                        for feat in stream_grass_pt.getFeatures():
                            coord_mapping[feat['stream']]=(feat.geometry().asPoint().x(),feat.geometry().asPoint().y())


                        '''
                        # making pairs of segments that should be merged
                        pair={}

                        for i in deletedNode:
                            pair[i] = [0,0]

                        for i in stream_network:
                            if stream_network[i].end_node in deletedNode:
                                pair[stream_network[i].end_node][0] = stream_network[i].segment_id
                            if stream_network[i].source_node in deletedNode:
                                pair[stream_network[i].source_node][1] = stream_network[i].segment_id

                        # IMPLEMENT MERGE OPERATION:
                        '''



                    # generate points along the stream lines: to extract depth across each point
                    param7 = { 'INPUT_RASTER' : path1+'BasinRaster.tif', 'INPUT_VECTOR' : filename2_1, 'OUTPUT' : path1+'StreamPoints.shp' }
                    processing.run("qgis:generatepointspixelcentroidsalongline", param7)
                    
                    
                    # remove duplucate points: previous result may have multiple points on same coordinate - removem them
                    param8 = { 'INPUT' : path1+'StreamPoints.shp', 'OUTPUT' : path1+'CleanStreamPoints.shp' }
                    processing.run("qgis:deleteduplicategeometries", param8)
                    

                    # add layers: jpoints -> junction points to get the coordinates of junction
                    spoints = self.iface.addVectorLayer(path1+'CleanStreamPoints.shp','','ogr')
                    jpoints = self.iface.addVectorLayer( path1+'JunctionPoints-grass.shp','','ogr')
                    
                    '''
                    # add new attributes to the stream vector
                    stream.dataProvider().addAttributes( [ QgsField("DEPTH", QVariant.Double, "double", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("BASIN AREA", QVariant.Double, "double", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("SLOPE", QVariant.Double, "double", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("B_WIDTH", QVariant.Double, "double", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("T_WIDTH", QVariant.Double, "double", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("SOURCES", QVariant.String, "text", 10, 5) ] )
                    stream.dataProvider().addAttributes( [ QgsField("Q", QVariant.Double, "double", 10, 5) ] )
                    '''
                    # add new attributes to the stream vector
                    stream_grass.dataProvider().addAttributes( [ QgsField("DEPTH", QVariant.Double, "double", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("BASIN AREA", QVariant.Double, "double", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("SLOPE", QVariant.Double, "double", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("B_WIDTH", QVariant.Double, "double", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("T_WIDTH", QVariant.Double, "double", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("SOURCES", QVariant.String, "text", 10, 5) ] )
                    stream_grass.dataProvider().addAttributes( [ QgsField("Q", QVariant.Double, "double", 10, 5) ] )


                    # get stream segment junction point coordinate and remove the layer
                    coor = [(f.geometry().asPoint().x(),f.geometry().asPoint().y()) for f in jpoints.getFeatures()]
                    QgsProject.instance().removeMapLayer(jpoints)
                    
                    
                    


                    # compute depth, slope and watershed area for each segment
                    for i in stream_network_grass:
                        if stream_network_grass[i].valid:
                            stream_network_grass[i].source_node_coord = coord_mapping[stream_network_grass[i].source_node]
                            stream_network_grass[i].end_node_coord = coord_mapping[stream_network_grass[i].end_node]
                            # stream_network[i].source_node_coord = coor[stream_network[i].source_node-1]
                            # stream_network[i].end_node_coord = coor[stream_network[i].end_node-1]
                            spoints.selectByExpression('"line_id"='+str(i-1))
                            temp = spoints.selectedFeatures()
                            stream_network_grass[i].depth, elevation_diffrance, stream_network_grass[i].watershed_area = self.getDepth(stream_network_grass[i],temp,
                                pixelSize, selectedLayer, i, root_path1, path2, maxWidth)
                            stream_network_grass[i].slope = elevation_diffrance/stream_network_grass[i].length if elevation_diffrance>0 else 0.001
                            stream_network_grass[i].differential_watershed_area = stream_network_grass[i].watershed_area

                    # remove points along the stream layer
                    QgsProject.instance().removeMapLayer(spoints)



                    # to transfer sources from segments with < minLength to its next segment
                    transferSource = {}
                    # to remove segments with -ve differential watershed area from source list of other segments
                    removeSource = []

                    # compute differential watershed area and source nodes list
                    for i in stream_network_grass:
                        for j in stream_network_grass:
                            if stream_network_grass[i].source_node == stream_network_grass[j].end_node:
                                if stream_network_grass[j].valid:
                                    stream_network_grass[i].sources.append(j)

                                    if stream_network_grass[i].valid:
                                        stream_network_grass[i].differential_watershed_area -= stream_network_grass[j].watershed_area
                                        if stream_network_grass[i].differential_watershed_area<0:     # if differential watershed area is -ve the segment is invalid   
                                            removeSource.append(i)                              # it need to be removed from sources of other network
                                    else:
                                        stream_network_grass[i].differential_watershed_area = 0
                                else:
                                    transferSource[j] = i                                       # here j is source of i
                                                                                                # j has length < minLength. its sources need to be included in its next segments


                    # transfaring sources from invalid segments (length < pixelSize*(sqrt(2))) and and recomputing differential watershed area                                                                        
                    for i in transferSource.keys():
                        stream_network_grass[transferSource[i]].sources += stream_network_grass[i].sources
                        stream_network_grass[transferSource[i]].differential_watershed_area -= sum(stream_network_grass[j].watershed_area for j in stream_network[i].sources)



                    # remove invalid sources (segments with -ve differential watershed area)
                    for seg in removeSource:
                        stream_network_grass[seg].valid = False
                        for i in stream_network_grass:
                            # no need to transfer source list, just remove the segment from source list of other segments
                            if seg in stream_network_grass[i].sources:
                                print("inv seg-",seg," has next segment ",i)
                                print("Source-",i," before : ",stream_network_grass[i].sources)
                                stream_network_grass[i].sources.remove(seg)

                    
                    # get peak Runoff
                    peakRunoff = self.getPeakRunoff(runoffFile)
                    if not peakRunoff:
                        return None


                    # features List: to store the features in dictionary format
                    streamFeaturesList = []

                    # update attribute Table
                    stream_grass.startEditing()
                    for i in stream_grass.getFeatures():
                        segment = stream_network_grass[i["SEGMENT_ID"]]
                        if segment.valid:
                            i['DEPTH'] = segment.depth
                            i['BASIN AREA'] = segment.differential_watershed_area
                            i['SLOPE'] = segment.slope
                            i['Q'] = self.getQValue(i["SEGMENT_ID"],stream_network_grass,peakRunoff)

                            # compute width
                            if segment.slope:
                                segment.bottom_width, segment.top_width = self.computeFeatures(segment.q_value,
                                    segment.depth,segment.slope,mannigs,sideSlope,i['strahler'])
                            else:
                                segment.bottom_width, segment.top_width = 0,0

                            try:
                                i['B_WIDTH'] = (float(segment.bottom_width))
                            except:
                                i['B_WIDTH'] = 1

                            try:
                                i['T_WIDTH'] = (float(segment.top_width))
                            except:
                                i['T_WIDTH'] = 1

                            i['SOURCES'] = (str(segment.sources)[1:-1])

                            streamFeaturesList.append(OrderedDict({'stream_id':str(i['SEGMENT_ID']), 'sources':i['SOURCES'],
                                'watershed_area':i['BASIN AREA']/10000, 'length':i['LENGTH']/1000, 'depth': i['DEPTH'], 'order': i['strahler'], 'width_bottom':i['B_WIDTH'],
                                'channel_slope': i['SLOPE'], 'fraction_deep_aquifer':frictionDeepAquifer, 'zch':sideSlope,
                                'hydraulic_conductivity':hydraulicConductivity, 'evaporation_coefficient':evaporationCoefficient, 'mannigs':mannigs,
                            'bank_flow_recession':bankFlowRecession, 'potential_evaporation':potentialEvaporation}))
                            
                        stream_grass.updateFeature(i)                        
                    stream_grass.commitChanges()


                    # save stream features in CSV File
                    with open(resultFileName, 'w', newline='') as csvfile:
                        fieldnames = ['stream_id', 'sources', 'watershed_area', 'length', 'depth', 'order', 'width_bottom', 'channel_slope', 'fraction_deep_aquifer',
                            'zch', 'hydraulic_conductivity', 'evaporation_coefficient', 'mannigs', 'bank_flow_recession', 'potential_evaporation']
                        writer = csv.DictWriter(csvfile, fieldnames=fieldnames)
                        writer.writeheader()
                        for i in streamFeaturesList:
                            writer.writerow(i)
                    

                    
                    # create Drainage class object
                    connected_streams = {}
                    for i in streamFeaturesList:
                        connected_streams[i['stream_id']] = Drainage.ConnectedStream(
                            Drainage.Stream.Channel(*[float(i[v]) for v in [
                                'watershed_area', 'length', 'width_bottom', 'channel_slope', 'fraction_deep_aquifer', 'zch',
                                'hydraulic_conductivity', 'evaporation_coefficient', 'mannigs', 'bank_flow_recession', 'potential_evaporation'
                            ]]),
                            [Drainage.Stream.Transient(volume_out=0, volume_stored_end_timestep=0)]
                        )
                        connected_streams[i['stream_id']].stream_id = i['stream_id']
                   

                    # get runoff data from input file
                    with open (runoffFile) as csv_file:
                        csv_reader = csv.reader(csv_file, delimiter=',')
                        next(csv_reader)
                        runoff_data = [ float(row[9])+float(row[12]) for row in csv_reader if row[9] != '' or row[12] != '']
                        
                    total_time_steps = len(runoff_data)




                    
                    for i in streamFeaturesList:
                        connected_streams[i['stream_id']].sources.extend([
                            connected_streams[v.strip()] for v in i['sources'].split(',') if v.strip() != ''
                        ])
                        
                        connected_streams[i['stream_id']].runoffs = runoff_data
                    
                    





                    drainage = Drainage(list(connected_streams.values()))

                    for i in range(total_time_steps):
        
                        for cs in drainage.connected_streams:
                            cs.next_runoff_per_area_in_watershed = cs.runoffs[i]

                        drainage.compute_drainage_model_transients_for_latest_time_step()


                    with open(resultFileName2, 'w', newline='') as f:
                        fieldnames = [
                            'runoff_per_area_in_watershed', 'swat_runoff', 'total_volume_stored', 'volume_in', 'discharge',
                            'transmission_loss', 'bankin', 'return_flow_from_bank', 'evaporation_loss', 'total_loss',
                            'volume_after_loss', 'volume_out', 'volume_stored_end_timestep', 'cross_section',
                            'depth_water_level', 'width_water_level', 'wetted_perimeter', 'hydraulic_radius',
                            'velocity', 'travel_time', 'fraction_time_step', 'storage_coeffecient'
                            ]
                        writer = csv.writer(f)
                        writer.writerow(['stream_id', 'time_step'] + fieldnames)
                        for cs in drainage.connected_streams:
                            #print(cs.stream_id,': Done')
                            for i in range(total_time_steps):
                                writer.writerow([cs.stream_id, str(i)] + [getattr(cs.transients[i], fn) for fn in fieldnames])

                    
            elif 1:
                QMessageBox.critical(self.iface.mainWindow(),
                         'QuickAPI error',
                         "Error Occeared during execution")
                
            else:
                self.iface.messageBar().pushMessage(
                    "Success", "Output files has been genetated successfully",
                    level=Qgis.Success, duration=10)
                
            
            
        ############################################################################